function [h]=edtopo_obcs(hold)
% edit topography
% see below for functions corners and landfill
colormap('default')
cmap=[[1 1 1]' colormap']';
colormap(cmap)
more off

h=hold;
[nx,ny]=size(h);

cnx=nx;cny=ny;
cx=nx/2;cy=ny/2;
ax=corners(cx,cy,cnx,cny,nx,ny);
sprintf('Axes = %i %i %i %i',ax)
cax=[min(min(h))-100 0];

% newh = depth value to which to change point using 1; can be
% reset using 0,a, or n
newh=0;
% hcut = memory of last depth changed;
% initialized to 999.9 so undo knows not to work
hcut=999.9;

% set count of open boundary points
nopbd = 0;

report('[SPACE] to end, 1=change point, 2=change box, 3=look\n')
report('0=set to zero, a=set to local average\n')
report('i=zoom in, o=zoom out, n=change new value, u=undo last\n')
report('f=fill (no undo)\n')
report('b=save point for open boundary conditions \n')

%keep looping until get a carriage return
while 1 % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 xx=ax(1):ax(2);
 yy=ax(3):ax(4);
 pcol(xx,yy, sq(h(xx,yy))' );axis(ax);caxis(cax);colorbar
 grid on

 [i,j,but]=ginput(1);
 i=round(i); i=max(i,0*i+1); i=min(i,0*i+nx);
 j=round(j); j=max(j,0*j+1); j=min(j,0*j+ny);

 if but == 1       % Button 1
  iii=i;
  jjj=j;
  hcut=h(iii,jjj);
  h(i,j)=newh;
  report('h(%i,%i)=%d\n',i,j,newh)
 elseif but == 2   % Button 2
  [i2,j2,but2]=ginput(1);
  if but2 == 2     % Repeat button 2
   i2=round(i2); i2=max(i2,0*i2+1); i2=min(i2,0*i2+nx);
   j2=round(j2); j2=max(j2,0*j2+1); j2=min(j2,0*j2+ny);
   iii=min(i,i2):max(i,i2);
   jjj=min(j,j2):max(j,j2);
   hcut=h(iii,jjj);
   h(iii,jjj)=newh;
   report('h(%i:%i,%i:%i)=%d\n',...
      min(i,i2),max(i,i2),min(j,j2),max(j,j2),newh)
  end
 elseif but == 3   % Button 3
  report('Value at h(%i,%i)=%8.0f\n',i,j,h(i,j))
 elseif but == 110 % but = 'n'
  newh=input('Enter new value:');
 elseif but == 117 % but = 'u'
  if hcut ~= 999.9
   h(iii,jjj)=hcut;
  end
 elseif but == 105 % but = 'i'
  cx=i;
  cy=j;
  cnx=max(16,round(cnx/2));
  cny=max(16,round(cny/2));
  ax=corners(cx,cy,cnx,cny,nx,ny);
  report('Axes = %i %i %i %i\n',ax)
 elseif but == 111 % but = 'o'
  cnx=min(nx,cnx*2);
  cny=min(ny,cny*2);
  ax=corners(cx,cy,cnx,cny,nx,ny);
  report('Axes = %i %i %i %i\n',ax)
 elseif but == 99  % but = 'c'
  cx=i;
  cy=j;
  ax=corners(cx,cy,cnx,cny,nx,ny);
  report('Axes = %i %i %i %i\n',ax)
 elseif but == 48  % but = '0'
  iii=i;
  jjj=j;
  hcut=h(iii,jjj);
  h(i,j)=0;
  report('h(%i,%i)=%d\n',i,j,0)
 elseif but == 97  % but = 'a'
  iii=i;
  jjj=j;
  hcut=h(iii,jjj);
  iiii=max(1,i-1):min(nx,i+1);
  jjjj=max(1,j-1):min(ny,j+1);
  htmp=h(iiii,jjjj);
  htmp=round( sum(sum(htmp))/prod(size(htmp~=0)) );
  h(i,j)=htmp;
  report('h(%i,%i)=%d\n',i,j,htmp)
 elseif but == 102  % but = 'f'
  h=landfill(h,i,j);
 elseif but == 98  % but = 'b'
  % open boundary point
  nopbd = nopbd + 1;
  iopbd(nopbd) = i 
  jopbd(nopbd) = j 
 elseif but == 32  % but = 'space'
  break
 else
  report('Unrecognised key %i\n',but)
 end

end % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

colormap('default')
pcol( sq(h)' );colorbar

if nopbd > 0
 report('%i open boundary points\n',nopbd)
 display([iopbd' jopbd']); 
end


% ------------------------------------------------------------------------------

function [ax]=corners(cx,cy,cnx,cny,nx,ny)

x0=cx-cnx/2;
x0=round(x0);
x0=max(1,x0);
x1=x0+cnx-1;
x1=min(nx,x1);
x0=x1-cnx+1;

y0=cy-cny/2;
y0=round(y0);
y0=max(1,y0);
y1=y0+cny-1;
y1=min(ny,y1);
y0=y1-cny+1;

ax=[x0 x1 y0 y1];

% ------------------------------------------------------------------------------

function [H]=landfill(H,i,j)

rmsk=0*H+1; rmsk(find(H==0))=0;
msk=0*H;

msk(i,j)=10;
n=sum(sum(msk));
nm1=-1;

im1=[1 1:size(H,1)-1];
ip1=[2:size(H,1) size(H,1)];
jm1=[1 1:size(H,2)-1];
jp1=[2:size(H,2) size(H,2)];

while (n~=nm1)
 msk=msk+msk(im1,:)+msk(ip1,:)+msk(:,jm1)+msk(:,jp1);
 msk( find(msk>1) )=10;
 msk=msk.*rmsk;
 nm1=n;
 n=sum(sum(msk));
end

H( find(msk==10) )=0;
