clear all;
close all
clc


%% Path and Grid.
fpath = '/net/wave3/ganeshgopal/WAVE5_DATA/GOM_OI_24DEG/FORCINGS/';
dpath = '/net/wave3/ganeshgopal/WAVE5_DATA/GOM_OI_24DEG/BATHY/';
opath = '/net/wave3/ganeshgopal/WAVE5_DATA/GOM_DART/OS_AMERICA/FIGS/';

eval(['load ' fpath 'GRID.mat']);
eval(['load ' fpath 'FMT.mat']);
lon2 = xc;
lat2 = yc;
h2 = rdslice([fpath 'bathymetry.bin',],[nxc nyc],1,fmt, Ieee);
h2(h2 == 0) = nan;
box = [lon2(1),lon2(end) lat2(1),lat2(end)];

%% Path and Grid.
fpath = '/net/wave3/ganeshgopal/GOM/FORCINGS/';
eval(['load ' fpath 'GRID.mat']);
eval(['load ' fpath 'FMT.mat']);
h1 = rdslice([fpath 'bathymetry.bin',],[nxc nyc],1,fmt, Ieee);
h1(h1 == 0) = nan;
lon1 = xc;
lat1 = yc;

pcolnan(lon1,lat1,h1');colorbar
hold on
adjbox_plot(box)
plot(-90.02698449+360, 27.19545638,'Linewidth',5,'marker','o','markersize',5,'color','b', 'markerfacecolor','b');
hold on
plot(-88.375+360, 28.75,'Linewidth',5,'marker','o','markersize',5,'color','w', 'markerfacecolor','w');
set(gca,'FontSize',14);
title(['GOM Model Domain: (1/10^o coarser resolution), (1/24^o finer resolution)'],'FontSize',14); 
xlabel('Longitude (deg) ','FontSize',14)
ylabel('Latitude (deg)','FontSize',14)

%% saving the figure
set(gcf,'Paperposition',[.5 .5 15 10]);
%% tell it about the paper orientation:
set(gcf,'PaperOrientation','landscape');
savename = ['model_topo_2.ps'];
print ('-dpsc2', [opath savename])



