% working on bathymetry retrieved from GEODAS
% web site.

% 10-minute dataset:
% GEODAS Design-a-Grid Retrieval  Key:global_5609
%Your Compressed File Size: 22.4 MegaBytes

%http://www.ngdc.noaa.gov/mgg/bathymetry/relief.html
%http://www.ngdc.noaa.gov/cgi-bin/mgg/gdas_rtvg

% see ~/lau/data/bathy/readme.dat
% just use matlab binary read

% basic path:
% laptop:
%bpath = '/home/bdc/lau';
% desktop:

function [bathy,xlon,ylat] = rdbathy;

bpath = '/net/bdc/';

%igrid = 10;
igrid = 2;
if (igrid == 10)
% for 10 minute grid:
% see /home/bdc/lau/data/bathy/global_5609_data/global_5609/global_5609.hdr
% NCOLS  2161 
% NROWS  1081 
% XLLCENTER -180.00000 
% YLLCENTER -90.00000 
% CELLSIZE 0.16666667 
% NODATA_VALUE  -32768 
% BYTEORDER LSBFIRST 
% NUMBERTYPE 2_BYTE_INTEGER 
% UNITS METERS 
% MIN_VALUE  -10483 
% MAX_VALUE    7304 

%file ='/home/bdc/lau/data/bathy/global_5609_data/global_5609/global_5609.bin';
nxg = 2161;
nyg = 1081;
dlon = 1/6;
dlat = 1/6;

file = 'data/bathy/global_5609_data/global_5609/global_5609.bin';
[fid mess]=fopen([bpath file],'r','ieee-le');
[arr count]=fread(fid,inf,'integer*2');
bathy = reshape(arr,nxg,nyg);
%bathy = reshape(arr,2161,1081);

elseif (igrid == 2)
disp('2 minute grid')
% 2 - minute grid (from header)
% ~/data/bathy/global_2_9382_data/global_2_9382/global_2_9382.hdr
nxg = 10801;
nyg = 5401;
dlon = 1/30;
dlat = 1/30;
file = 'data/bathy/global_2_9382_data/global_2_9382/global_2_9382.bin';
[fid mess]=fopen([bpath file],'r','ieee-le');
[arr count]=fread(fid,inf,'integer*2');
bathy = reshape(arr,nxg,nyg);

end

clear arr
%%% coordinate axes
ylat = -90:dlat:90;
xlon = -180:dlon:180;

%%% check that lengths match
%disp([' nxg, length(xlon): ' num2str(nxg) ', ' num2str(length(xlon))])
%disp([' nyg, length(ylat): ' num2str(nyg) ', ' num2str(length(ylat))])

%%% to plot  use axes
%imagesc(xlon,ylat,rot90(bathy))
%axis xy
%colorbar

%itest = 0;
%if (itest == 1)
  % test interpolation points near hawaii
%  xtest = [-156.5 :1: -154.5];
%  ytest = [18.5 : 1 :20.5];
%  bathy = rot90(bathy);
%  ztest = interp2(xlon,ylat,(bathy),xtest,ytest,'nearest');
  %size(xtest)
%end
